if(typeof Virtuemart === "undefined")
	{
		var Virtuemart = {
			setproducttype : function (form, id) {
				
				Virtuemart.initDefaults(); 
				var prices = form.parent(".productdetails").find(".product-price");
				if (0 == prices.length) {
					prices = jQuery("#productPrice" + id);
				}
				Virtuemart.log('event: setproducttype'); 
				var query = Virtuemart.getQuery(form, 'productdetails', 'recalculate'); 
				query += '&virtuemart_product_id='+id;
				
				if (prices != null)
				prices.fadeTo("fast", 0.75);
				else return; 
				
				jQuery.ajax({
				type: "POST",
				url: window.vmSiteurl + 'index.php?option=com_virtuemart&nosef=1&view=productdetails&task=recalculate&tmpl=component&format=json' + window.vmLang,
				data: query,
				cache: false,
				complete: 
					function (datasRaw, textStatus) {
					if (!(datasRaw.readyState==4 && datasRaw.status==200)) return;
					Virtuemart.log(datasRaw); 
					var datas = Virtuemart.parseJson(datasRaw); 
						prices.fadeTo("fast", 1);
						// refresh price
						for (var key in datas) {
							var value = datas[key];
							if (value!=0) prices.find("span.Price"+key).show().html(value);
							else prices.find(".Price"+key).html(0).hide();
						}
					}
					});
				return false; // prevent reload
				
				
			},
			productUpdate : function() {

                // This Event Gets Fired As Soon As The New Product
                // Was Added To The Cart
                // This Way Third Party Developer Can Include Their Own
                // Add To Cart Module And Listen To The Event: "updateVirtueMartCartModule"
				Virtuemart.initDefaults(); 
				Virtuemart.log('event: productUpdate'); 
                jQuery('body').trigger('updateVirtueMartCartModule');
				//stAn, backward compatibility: 
				if (typeof jQuery.fn != 'undefined')
				if (typeof jQuery.fn.updateVirtueMartCartModule == 'undefined')
				 {
				   
				   jQuery.ajax({
				   type: "POST",
				   url: window.vmSiteurl+"index.php?option=com_virtuemart&nosef=1&view=cart&task=viewJS&format=json"+window.vmLang,
				   data: '',
				   cache: false,
				   complete: 
					function (datasRaw, textStatus) {
					if (!(datasRaw.readyState==4 && datasRaw.status==200)) return;
						var datas = Virtuemart.parseJson(datasRaw); 
						if (!(datas != null)) return; 

						var mod = jQuery(".vmCartModule"); 
						if (typeof datas.totalProduct != 'undefined')
						if (datas.totalProduct >0) {
							mod.find(".vm_cart_products").html("");
							jQuery.each(datas.products, function(key, val) {
								jQuery("#hiddencontainer .container").clone().appendTo(".vmCartModule .vm_cart_products");
								jQuery.each(val, function(key, val) {
									if (jQuery("#hiddencontainer .container ."+key)) mod.find(".vm_cart_products ."+key+":last").html(val) ;
								});
							});
							mod.find(".total").html(datas.billTotal);
							mod.find(".show_cart").html(datas.cart_show);
						}
						if (datas.totalProductTxt != 'undefined')
						mod.find(".total_products").html(datas.totalProductTxt);
					}
				 });
				 }

			},
			sendtocart : function (form){
				Virtuemart.initDefaults(); 
				Virtuemart.log('event: sendtocart'); 
				if (Virtuemart.addtocart_popup ==1) {
					Virtuemart.cartEffect(form) ;
				} else {
					form.append('<input type="hidden" name="task" value="add" />');
					form.task = 'add'; 
					form.submit();
				}
			},
			cartEffect : function(form) {

                
				
				Virtuemart.initDefaults(); 
				Virtuemart.log('event: cartEffect'); 
				
				if (typeof usefancy != 'undefined')
                if(usefancy){
                    jQuery.fancybox.showActivity();
                }
				
				var query = Virtuemart.getQuery(form, 'cart', 'addJS'); 
				
				 jQuery.ajax({
				   type: "POST",
				   url: window.vmSiteurl+'index.php?option=com_virtuemart&nosef=1&view=cart&task=addJS&format=json'+window.vmLang,
				   data: query,
				   cache: false,
				   complete: 
					function (datasRaw, textStatus) {
					if (!(datasRaw.readyState==4 && datasRaw.status==200)) return;
						var datas = Virtuemart.parseJson(datasRaw); 
						if (!(datas != null)) return; 

                    if(datas.stat ==1){

                        var txt = datas.msg;
                    } else if(datas.stat ==2){
                        var txt = datas.msg +"<H4>"+form.find(".pname").val()+"</H4>";
                    } else {
                        var txt = "<H4>"+vmCartError+"</H4>"+datas.msg;
                    }
                    if ((typeof usefancy != 'undefined') && (usefancy)) {
					    if (typeof jQuery.fancybox != 'undefined')
                        jQuery.fancybox({
                                "titlePosition" : 	"inside",
                                "transitionIn"	:	"fade",
                                "transitionOut"	:	"fade",
                                "changeFade"    :   "fast",
                                "type"			:	"html",
                                "autoCenter"    :   true,
                                "closeBtn"      :   false,
                                "closeClick"    :   false,
                                "content"       :   txt
                            }
                        );
                    } else {
					    //stAn, in 90 percent of cases of problems with add to cart, $.facebox.settings is not defined
						//the reason for this issue is a dual inclusion of jquery library which automatically unsets previous objects
					    if (typeof jQuery.facebox != 'undefined')
						if (typeof jQuery.facebox.settings != 'undefined')
						{
                         jQuery.facebox.settings.closeImage = closeImage;
                         jQuery.facebox.settings.loadingImage = loadingImage;
                         //$.facebox.settings.faceboxHtml = faceboxHtml;
                         jQuery.facebox({ text: txt }, 'my-groovy-style');
						}
                    }


                    Virtuemart.productUpdate();
					}
                });

               
			},
			product : function(carts) {
			    
				if (carts != null)
				if (typeof carts.each != 'undefined')
				carts.each(function(){
				  
					var cart = jQuery(this);
					var step=cart.find('input[name="quantity"]');
					var addtocart = cart.find('input.addtocart-button');
					var plus   = cart.find('.quantity-plus');
					var minus  = cart.find('.quantity-minus');
					var select = cart.find('select:not(.no-vm-bind)');
					var radio = cart.find('input:radio:not(.no-vm-bind)');
					var virtuemart_product_id = cart.find('input[name="virtuemart_product_id[]"]').val();
					if (virtuemart_product_id.length == 0)
					virtuemart_product_id = cart.find('input[name="virtuemart_product_id"]').val();
					
					var quantity = cart.find('.quantity-input');

                    var Ste = parseInt(step.val());
                    //Fallback for layouts lower than 2.0.18b
                    if(isNaN(Ste)){
                        Ste = 1;
                    }
					
					if (addtocart.prop('binded')==true) return; 
					addtocart.prop('binded', true); 
					
					addtocart.click(function(e) {
						Virtuemart.sendtocart(cart);
						return false;
					});
					plus.click(function() {
					    //stAn, i know max does not like decimals in quantity, but why to block it here
						var Qtt = parseFloat(quantity.val());
						if (!isNaN(Qtt)) {
							quantity.val(Qtt + Ste);
						Virtuemart.setproducttype(cart,virtuemart_product_id);
						}
						
					});
					minus.click(function() {
					   //stAn, i know max does not like decimals in quantity, but why to block it here
						var Qtt = parseFloat(quantity.val());
						if (!isNaN(Qtt) && Qtt>Ste) {
							quantity.val(Qtt - Ste);
						} else quantity.val(Ste);
						Virtuemart.setproducttype(cart,virtuemart_product_id);
					});
					select.change(function() {
						Virtuemart.setproducttype(cart,virtuemart_product_id);
					});
					radio.change(function() {
						Virtuemart.setproducttype(cart,virtuemart_product_id);
					});
					quantity.keyup(function() {
						Virtuemart.setproducttype(cart,virtuemart_product_id);
					});
				});

			},
			log: function()
			{
			   //usage: Virtuemart.log(object); to get it shown in the console
			   // this usage is compatible with old browsers and all IE versions
			   if ((typeof Virtuemart.virtuemart_debug != 'undefined') && (Virtuemart.virtuemart_debug == true))
			   if (typeof console != 'undefined')
			   if (typeof console.log != 'undefined')
			   if (console.log != null)
			   for (var i = 0; i < arguments.length; i++) {
				console.log(arguments[i]);
				}
			   
			}, 
			parseJson: function(datas)
			{
					Virtuemart.log(datas); 
					var json = datas.responseText; 
					var datasJson = jQuery.parseJSON(json); 
					if (!(datasJson != null)) 
					{ 
					   //the json deserialization failed 
					   part = datas.responseText.indexOf('{"'); 
					   resp = datas.responseText.substr(part); 
					   datasJson = jQuery.parseJSON(resp); 
					}
					return datasJson; 
			},
			initDefaults: function()
			{
			   if (typeof window.vmSiteurl == 'undefined')
			   window.vmSiteurl = '/'; 
			  
			   if (typeof window.vmLang == 'undefined')
			   window.vmLang = ''; 
			   if (typeof Virtuemart.addtocart_popup == 'undefined')
			    {
				  // failsafe do not show popup when js is broken
				  Virtuemart.addtocart_popup = false; 
				}
				if (typeof window.usefancy == 'undefined')
				window.usefancy = false; 
			}, 
			getQuery: function(form, view, task)
			{
			  var datas = form.serializeArray(); 
			  var query = ''; 
				for (var i=0; i<datas.length; i++)
				{
				  if (datas[i].name != 'undefined')
				  {
				    if (datas[i].name == 'task') continue; 
					if (datas[i].name == 'view') continue; 
				    //stAn - no other characters then & have to be encoded here, all are handled by apache and other systems
				    query += '&'+datas[i].name+'='+datas[i].value.split("&").join("%26");
				  }
				}
				// just a failsafe, can be removed: 
			   query = query.split("&view=cart").join("&view="+view);
			   query = query.split("&task=add").join("&view="+task);
			   return query; 
			},
			virtuemart_debug: false, 
			addtocart_popup: false
		};
		if (typeof jQuery != 'undefined')
		{
		jQuery.noConflict();
		jQuery(document).ready(function() {

			Virtuemart.product(jQuery("form.product"));

			jQuery("form.js-recalculate").each(function(){
				if (jQuery(this).find(".product-fields").length && !jQuery(this).find(".no-vm-bind").length) {
					var id= jQuery(this).find('input[name="virtuemart_product_id[]"]').val();
					Virtuemart.setproducttype(jQuery(this),id);

				}
			});
		});
		}
	}
